datacache <- new.env(hash=TRUE, parent=emptyenv())

hcg110hsrefseq <- function() showQCData("hcg110hsrefseq", datacache)
hcg110hsrefseq_dbconn <- function() dbconn(datacache)
hcg110hsrefseq_dbfile <- function() dbfile(datacache)
hcg110hsrefseq_dbschema <- function(file="", show.indices=FALSE) dbschema(datacache, file=file, show.indices=show.indices)
hcg110hsrefseq_dbInfo <- function() dbInfo(datacache)

hcg110hsrefseqORGANISM <- "Homo sapiens"

.onLoad <- function(libname, pkgname)
{
    ## Connect to the SQLite DB
    dbfile <- system.file("extdata", "hcg110hsrefseq.sqlite", package=pkgname, lib.loc=libname)
    assign("dbfile", dbfile, envir=datacache)
    dbconn <- dbFileConnect(dbfile)
    assign("dbconn", dbconn, envir=datacache)

    ## Create the OrgDb object
    sPkgname <- sub(".db$","",pkgname)
    txdb <- loadDb(system.file("extdata", paste(sPkgname,
      ".sqlite",sep=""), package=pkgname, lib.loc=libname),
                   packageName=pkgname)    
    dbNewname <- AnnotationDbi:::dbObjectName(pkgname,"ChipDb")
    ns <- asNamespace(pkgname)
    assign(dbNewname, txdb, envir=ns)
    namespaceExport(ns, dbNewname)
        
    ## Create the AnnObj instances
    ann_objs <- createAnnObjs.SchemaChoice("HUMANCHIP_DB", "hcg110hsrefseq", "chip hcg110hsrefseq", dbconn, datacache)
    mergeToNamespaceAndExport(ann_objs, pkgname)
    packageStartupMessage(AnnotationDbi:::annoStartupMessages("hcg110hsrefseq.db"))
}

.onUnload <- function(libpath)
{
    dbFileDisconnect(hcg110hsrefseq_dbconn())
}

